Index: src/org/opencms/workplace/explorer/CmsTree.java
===================================================================
RCS file: /usr/local/cvs/opencms/src/org/opencms/workplace/explorer/CmsTree.java,v
retrieving revision 1.34
diff -u -r1.34 CmsTree.java
--- src/org/opencms/workplace/explorer/CmsTree.java	18 Jan 2010 10:03:13 -0000	1.34
+++ src/org/opencms/workplace/explorer/CmsTree.java	24 Aug 2010 16:43:28 -0000
@@ -122,6 +122,12 @@
     /** Type name for showing the tree in a widget dialog. */
     private static final String TYPE_VFSWIDGET = "vfswidget";
 
+    /** Request parameter name for the resourcetype-ids parameter. */
+    public static final String PARAM_RESOURCETYPE_IDS = "resourcetypeIds";
+
+    /** delimiter for ResourcetypeIds. */
+    public static final String PARAM_RESOURCETYPE_IDS_DELIMITER = ",";
+
     /** Indicates if only folders or files and folders should be included in the tree. */
     private boolean m_includeFiles;
 
@@ -146,6 +152,9 @@
     /** The type of the tree (e.g. "copy", "project" etc.). */
     private String m_treeType;
 
+    /** The delimited list of resource type ids. */
+    private String m_resourcetypeIds;
+
     /**
      * Public constructor.<p>
      * 
@@ -432,7 +441,11 @@
                     }
                 }
             }
-
+            
+            if (getResourcetypeIds() != null) {
+                resources = filterResourceTypes(resources);
+            }
+            
             // now output all the tree nodes
             Iterator i = resources.iterator();
             while (i.hasNext()) {
@@ -449,7 +462,7 @@
                         grey = true;
                     }
                 }
-
+                
                 result.append(getNode(
                     resource.getRootPath(),
                     resource.getName(),
@@ -501,6 +514,10 @@
                 }
             }
 
+            if (getResourcetypeIds() != null) {
+                result.append("parent.setResourcetypeIds('").append(getResourcetypeIds()).append("');\n");
+            }
+
             result.append("}\n");
         } finally {
             if (storedSiteRoot != null) {
@@ -582,6 +599,7 @@
         boolean rootloaded = Boolean.valueOf(request.getParameter(PARAM_ROOTLOADED)).booleanValue();
         String resource = request.getParameter(PARAM_RESOURCE);
 
+        setResourcetypeIds(request.getParameter(PARAM_RESOURCETYPE_IDS));
         setTreeType(request.getParameter(PARAM_TYPE));
         String treeSite = request.getParameter(PARAM_TREESITE);
         if ((getTreeType() != null) && (treeSite != null)) {
@@ -824,7 +842,7 @@
      * @return error information output
      */
     private String printError(Throwable t) {
-
+        LOG.error(t.getMessage(), t);
         StringBuffer result = new StringBuffer(1024);
         result.append("/*\n");
         result.append(CmsStringUtil.escapeHtml(t.getMessage()));
@@ -893,4 +911,64 @@
 
         m_treeType = type;
     }
+
+    /**
+     * Sets the resource types to accept.<p>
+     * 
+     * @param resourcetypeIds the resource types to accept (delimited list)
+     */
+    public void setResourcetypeIds(String resourcetypeIds) {
+
+        m_resourcetypeIds = resourcetypeIds;
+    }
+
+    /**
+     * Returns the resource types to accept.<p>
+     * 
+     * @return resource types to accept
+     */
+    public String getResourcetypeIds() {
+
+        return m_resourcetypeIds;
+    }
+
+
+    /**
+     * Filters the restricted resources types.
+     * @param resources All Resources
+     * @return filtered resources.
+     */
+    private List<CmsResource> filterResourceTypes(List<CmsResource> resources) {
+        List<CmsResource> result = new ArrayList<CmsResource>();
+        
+        for (CmsResource cmsResource : resources) {
+            if (getResourcetypeIdsAsList().contains(Integer.valueOf(cmsResource.getTypeId()))) {
+                result.add(cmsResource);
+            }
+        }
+        
+        return result;
+    }
+
+    /**
+     * @return
+     */
+    private List<Integer> getResourcetypeIdsAsList() {
+
+        List<Integer> result = new ArrayList<Integer>();
+        //always show folder
+        result.add(Integer.valueOf(0));
+        
+        String[] splitedIdsAsString = CmsStringUtil.splitAsArray(m_resourcetypeIds, PARAM_RESOURCETYPE_IDS_DELIMITER);
+        for (int i = 0; i < splitedIdsAsString.length; i++) {
+            String idString = splitedIdsAsString[i];
+            try {
+                result.add(Integer.valueOf(idString.trim()));
+            } catch (NumberFormatException e) {
+                LOG.error("The resourcTypeIds '" + m_resourcetypeIds + "' contains invalid characters: " + e.getMessage());
+            }
+        }
+        
+        return result;
+    }
 }
\ No newline at end of file
Index: src/org/opencms/workplace/list/CmsListResourceTypeIconAction.java
===================================================================
RCS file: /usr/local/cvs/opencms/src/org/opencms/workplace/list/CmsListResourceTypeIconAction.java,v
retrieving revision 1.8
diff -u -r1.8 CmsListResourceTypeIconAction.java
--- src/org/opencms/workplace/list/CmsListResourceTypeIconAction.java	18 Jan 2010 10:02:15 -0000	1.8
+++ src/org/opencms/workplace/list/CmsListResourceTypeIconAction.java	24 Aug 2010 16:43:28 -0000
@@ -31,7 +31,9 @@
 
 package org.opencms.workplace.list;
 
+import org.apache.commons.logging.Log;
 import org.opencms.i18n.CmsMessageContainer;
+import org.opencms.main.CmsLog;
 import org.opencms.main.OpenCms;
 import org.opencms.util.CmsStringUtil;
 import org.opencms.workplace.CmsWorkplace;
@@ -49,6 +51,9 @@
  */
 public class CmsListResourceTypeIconAction extends CmsListExplorerDirectAction {
 
+    /** The log object for this class. */
+    private static final Log LOG = CmsLog.getLog(CmsListResourceTypeIconAction.class);
+    
     /**
      * Default Constructor.<p>
      * 
@@ -148,7 +153,7 @@
         html.append(name);
         html.append("'");
         html.append(" style='display: block; width: 20px; height: 20px;'>");
-        if (CmsStringUtil.isNotEmptyOrWhitespaceOnly(iconPath)) {
+        if (CmsStringUtil.isNotEmptyOrWhitespaceOnly(iconPath) && hasFileExtension(iconPath)) {
             html.append("<img src='");
             html.append(CmsWorkplace.getSkinUri());
             if (!enabled) {
@@ -195,4 +200,12 @@
         }
         return html.toString();
     }
+
+    private boolean hasFileExtension(String iconPath) {
+        boolean hasFileExtension = iconPath.indexOf('.') != -1;
+        if (!hasFileExtension) {
+            LOG.warn("The filename seems invalid: '" + iconPath + "' (no File-Extension).");
+        }
+        return hasFileExtension;
+    }
 }
Index: src/org/opencms/xml/CmsXmlComplexTypeSequence.java
===================================================================
RCS file: /usr/local/cvs/opencms/src/org/opencms/xml/CmsXmlComplexTypeSequence.java,v
retrieving revision 1.8
diff -u -r1.8 CmsXmlComplexTypeSequence.java
--- src/org/opencms/xml/CmsXmlComplexTypeSequence.java	18 Jan 2010 10:04:10 -0000	1.8
+++ src/org/opencms/xml/CmsXmlComplexTypeSequence.java	24 Aug 2010 16:43:28 -0000
@@ -55,18 +55,23 @@
     /** The type sequence elements. */
     private List<I_CmsXmlSchemaType> m_sequence;
 
+    /** Returns true if this sequence is created from a {@link CmsXmlContentDefinition#XSD_NODE_CHOICE}-Element. */
+    protected boolean m_isChoiceSequence;
+
     /**
      * Creates a new complex type sequence data structure.<p>
      * 
      * @param name the name of the sequence
      * @param sequence the type sequence element list
      * @param hasLanguageAttribute indicates if a "language" attribute is present
+     * @param isChoiceSequence the type choice element list
      */
-    protected CmsXmlComplexTypeSequence(String name, List<I_CmsXmlSchemaType> sequence, boolean hasLanguageAttribute) {
+    protected CmsXmlComplexTypeSequence(String name, List sequence, boolean hasLanguageAttribute, boolean isChoiceSequence) {
 
         m_name = name;
         m_sequence = sequence;
         m_hasLanguageAttribute = hasLanguageAttribute;
+        m_isChoiceSequence = isChoiceSequence;
     }
 
     /**
Index: src/org/opencms/xml/CmsXmlContentDefinition.java
===================================================================
RCS file: /usr/local/cvs/opencms/src/org/opencms/xml/CmsXmlContentDefinition.java,v
retrieving revision 1.47
diff -u -r1.47 CmsXmlContentDefinition.java
--- src/org/opencms/xml/CmsXmlContentDefinition.java	18 Jan 2010 10:04:12 -0000	1.47
+++ src/org/opencms/xml/CmsXmlContentDefinition.java	24 Aug 2010 16:43:28 -0000
@@ -146,6 +146,9 @@
     /** Constant for the "sequence" node in the XML schema namespace. */
     public static final QName XSD_NODE_SEQUENCE = QName.get("sequence", XSD_NAMESPACE);
 
+    /** Constant for the "choice" node in the XML schema namespace. */
+    public static final QName XSD_NODE_CHOICE = QName.get("choice", XSD_NAMESPACE);
+    
     /** The XML content handler. */
     private I_CmsXmlContentHandler m_contentHandler;
 
@@ -158,6 +161,9 @@
     /** The outer element name of the content definition (language sequence). */
     private String m_outerName;
 
+    /** Returns true if this sequence is created from a {@link #XSD_NODE_CHOICE}-Element. */
+    private boolean m_isChoiceSequence;
+
     /** The location from which the XML schema was read (XML system id). */
     private String m_schemaLocation;
 
@@ -523,15 +529,21 @@
             // no error: then the language attribute is valid
             hasLanguageAttribute = true;
         }
-
+        
+        boolean isChoice = false;
+        
         // check the main element type sequence
         Element typeSequence = mainElements.get(0);
         if (!XSD_NODE_SEQUENCE.equals(typeSequence.getQName())) {
+            if (!XSD_NODE_CHOICE.equals(typeSequence.getQName())) {
             throw new CmsXmlException(Messages.get().container(
                 Messages.ERR_CD_ELEMENT_NAME_3,
                 typeSequence.getUniquePath(),
                 XSD_NODE_SEQUENCE.getQualifiedName(),
                 typeSequence.getQName().getQualifiedName()));
+            } else {
+                isChoice = true;
+            }
         }
 
         // check the type definition sequence
@@ -553,7 +565,7 @@
             CmsXmlContentTypeManager typeManager = OpenCms.getXmlContentTypeManager();
             Iterator<Element> i = typeSequenceElements.iterator();
             while (i.hasNext()) {
-                sequence.add(typeManager.getContentType(i.next(), includes));
+                sequence.add(typeManager.getContentType((Element)i.next(), includes, isChoice));
             }
         } else {
             // generate a nested content definition for the main type sequence
@@ -569,7 +581,7 @@
         }
 
         // return a data structure with the collected values
-        return new CmsXmlComplexTypeSequence(name, sequence, hasLanguageAttribute);
+        return new CmsXmlComplexTypeSequence(name, sequence, hasLanguageAttribute, isChoice);
     }
 
     /**
@@ -704,8 +716,8 @@
         result.setInnerName(outer.getName());
 
         // get the inner element sequence, this must be the second element 
-        CmsXmlComplexTypeSequence innerSequence = complexTypeData.get(1);
-
+        CmsXmlComplexTypeSequence innerSequence = (CmsXmlComplexTypeSequence)complexTypeData.get(1);
+        result.m_isChoiceSequence =innerSequence.m_isChoiceSequence;
         // add the types from the main sequence node
         Iterator<I_CmsXmlSchemaType> it = innerSequence.getSequence().iterator();
         while (it.hasNext()) {
@@ -852,6 +864,7 @@
         result.m_contentHandler = m_contentHandler;
         result.m_typeName = m_typeName;
         result.m_includes = m_includes;
+        result.m_isChoiceSequence = m_isChoiceSequence;
         return result;
     }
 
@@ -1174,4 +1187,16 @@
 
         m_outerName = outerName;
     }
+    
+
+    /**
+     * Returns <code>true</code> if this sequence is created from a {@link #XSD_NODE_CHOICE}-Element. 
+     * 
+     * @return <code>true</code> if this sequence is created from a {@link #XSD_NODE_CHOICE}-Element. 
+     * 
+     * @see CmsXmlNestedContentDefinition
+     */
+    public boolean isChoiceType() {
+        return m_isChoiceSequence;
+    }
 }
\ No newline at end of file
Index: src/org/opencms/xml/CmsXmlContentTypeManager.java
===================================================================
RCS file: /usr/local/cvs/opencms/src/org/opencms/xml/CmsXmlContentTypeManager.java,v
retrieving revision 1.40
diff -u -r1.40 CmsXmlContentTypeManager.java
--- src/org/opencms/xml/CmsXmlContentTypeManager.java	17 Jun 2010 13:06:37 -0000	1.40
+++ src/org/opencms/xml/CmsXmlContentTypeManager.java	24 Aug 2010 16:43:28 -0000
@@ -327,15 +327,19 @@
      * Generates an initialized instance of a XML content type definition
      * from the given XML schema element.<p>
      * 
-     * @param typeElement the element to generate the XML content type definition from
-     * @param nestedDefinitions the nested (included) XML content sub-definitions
+     * @param typeElement
+     *          The element to generate the XML content type definition from
+     * @param nestedDefinitions
+     *          The nested (included) XML content sub-definitions
+     * @param isChoice
+     *          true if this node is an element of a Choice XSD element.
+     *          In this case the maxOccurs is always handled as "1" and minOccurs is always handled as "0".
      * 
      * @return an initialized instance of a XML content type definition
      * @throws CmsXmlException in case the element does not describe a valid XML content type definition
      */
-    public I_CmsXmlSchemaType getContentType(Element typeElement, Set<CmsXmlContentDefinition> nestedDefinitions)
+    public I_CmsXmlSchemaType getContentType(Element typeElement, Set nestedDefinitions, boolean isChoice)
     throws CmsXmlException {
-
         if (!CmsXmlContentDefinition.XSD_NODE_ELEMENT.equals(typeElement.getQName())) {
             throw new CmsXmlException(Messages.get().container(Messages.ERR_INVALID_CD_SCHEMA_STRUCTURE_0));
         }
@@ -348,7 +352,12 @@
         String defaultValue = typeElement.attributeValue(CmsXmlContentDefinition.XSD_ATTRIBUTE_DEFAULT);
         String maxOccrs = typeElement.attributeValue(CmsXmlContentDefinition.XSD_ATTRIBUTE_MAX_OCCURS);
         String minOccrs = typeElement.attributeValue(CmsXmlContentDefinition.XSD_ATTRIBUTE_MIN_OCCURS);
-
+        // a schemyType inside a Choice-ContentDefinition can only occurred one time.
+        if (isChoice) {
+            minOccrs = CmsXmlContentDefinition.XSD_ATTRIBUTE_VALUE_ZERO;
+            maxOccrs = "1";
+        }
+        
         if (CmsStringUtil.isEmpty(elementName) || CmsStringUtil.isEmpty(typeName)) {
             throw new CmsXmlException(Messages.get().container(Messages.ERR_INVALID_CD_SCHEMA_STRUCTURE_0));
         }
@@ -365,7 +374,14 @@
                 if (typeName.equals(cd.getTypeName())) {
 
                     simpleType = false;
-                    return new CmsXmlNestedContentDefinition(cd, elementName, minOccrs, maxOccrs);
+                    if (cd.isChoiceType()) {
+                        // A Choice Element itself is always optional.
+                        // the initial XML content (create new resource) can not be automatically generated if minOccurs > 0
+                        // the editor must choose the sub element!
+                        return new CmsXmlNestedContentDefinition(cd, elementName, CmsXmlContentDefinition.XSD_ATTRIBUTE_VALUE_ZERO, maxOccrs);
+                    } else {
+                        return new CmsXmlNestedContentDefinition(cd, elementName, minOccrs, maxOccrs);
+                    }
                 }
             }
 
Index: src/org/opencms/xml/CmsXmlEntityResolver.java
===================================================================
RCS file: /usr/local/cvs/opencms/src/org/opencms/xml/CmsXmlEntityResolver.java,v
retrieving revision 1.35
diff -u -r1.35 CmsXmlEntityResolver.java
--- src/org/opencms/xml/CmsXmlEntityResolver.java	18 Jan 2010 10:04:11 -0000	1.35
+++ src/org/opencms/xml/CmsXmlEntityResolver.java	24 Aug 2010 16:43:28 -0000
@@ -32,15 +32,18 @@
 package org.opencms.xml;
 
 import org.opencms.configuration.CmsConfigurationManager;
+import org.opencms.db.CmsPublishedResource;
 import org.opencms.file.CmsFile;
 import org.opencms.file.CmsObject;
 import org.opencms.file.CmsResource;
 import org.opencms.file.CmsResourceFilter;
 import org.opencms.main.CmsEvent;
+import org.opencms.main.CmsException;
 import org.opencms.main.CmsLog;
 import org.opencms.main.I_CmsEventListener;
 import org.opencms.main.OpenCms;
 import org.opencms.util.CmsFileUtil;
+import org.opencms.util.CmsUUID;
 import org.opencms.xml.page.CmsXmlPage;
 
 import java.io.ByteArrayInputStream;
@@ -159,13 +162,13 @@
     private static void initCaches() {
 
         if (m_cacheTemporary == null) {
-            Map<String, byte[]> cacheTemporary = new LRUMap(128);
+            Map<String, byte[]> cacheTemporary = new LRUMap(1024);
             m_cacheTemporary = Collections.synchronizedMap(cacheTemporary);
 
             Map<String, byte[]> cachePermanent = new HashMap<String, byte[]>(32);
             m_cachePermanent = Collections.synchronizedMap(cachePermanent);
 
-            Map<String, CmsXmlContentDefinition> cacheContentDefinitions = new LRUMap(64);
+            Map<String, CmsXmlContentDefinition> cacheContentDefinitions = new LRUMap(512);
             m_cacheContentDefinitions = Collections.synchronizedMap(cacheContentDefinitions);
         }
         if (OpenCms.getRunLevel() > OpenCms.RUNLEVEL_1_CORE_OBJECT) {
@@ -223,6 +226,18 @@
         CmsResource resource;
         switch (event.getType()) {
             case I_CmsEventListener.EVENT_PUBLISH_PROJECT:
+                // only flush cache if a Schema definition where published.
+                CmsUUID publishHistoryId = new CmsUUID(
+                    (String) event.getData().get(I_CmsEventListener.KEY_PUBLISHID));
+
+                if (isSchemaDefinitionInPublishList(publishHistoryId)) {
+                    m_cacheTemporary.clear();
+                    m_cacheContentDefinitions.clear();
+                    if (LOG.isDebugEnabled()) {
+                        LOG.debug(Messages.get().getBundle().key(Messages.LOG_ER_FLUSHED_CACHES_0));
+                    }
+                }
+                break;
             case I_CmsEventListener.EVENT_CLEAR_CACHES:
                 // flush cache   
                 m_cacheTemporary.clear();
@@ -248,6 +263,25 @@
         }
     }
 
+    private boolean isSchemaDefinitionInPublishList(CmsUUID publishHistoryId) {
+        try {
+            List<CmsPublishedResource> publishedResources = m_cms.readPublishedResources(publishHistoryId);
+            for (CmsPublishedResource cmsPublishedResource : publishedResources) {
+                String resourceRootPath = cmsPublishedResource.getRootPath();
+                String resourceRootPathLowerCase = resourceRootPath.toLowerCase();
+                if (resourceRootPathLowerCase.endsWith(".xsd")
+                    || resourceRootPathLowerCase.endsWith(".dtd")
+                    || m_cacheTemporary.containsKey(getCacheKey(resourceRootPath, true))) {
+                    return true;
+                }
+            }
+        } catch (CmsException e) {
+            // error reading published Resources.
+            LOG.warn(e.getMessage(), e);
+        }
+        return false;
+    }
+
     /**
      * Looks up the given XML content definition system id in the internal content definition cache.<p> 
      * 
Index: test/org/opencms/widgets/TestVfsFileWidgetConfiguration.java
===================================================================
RCS file: test/org/opencms/widgets/TestVfsFileWidgetConfiguration.java
diff -N test/org/opencms/widgets/TestVfsFileWidgetConfiguration.java
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ test/org/opencms/widgets/TestVfsFileWidgetConfiguration.java	1 Jan 1970 00:00:00 -0000
@@ -0,0 +1,134 @@
+/*
+ * File   : $Source$
+ * Date   : $Date$
+ * Version: $Revision$
+ *
+ * This library is part of OpenCms -
+ * the Open Source Content Management System
+ *
+ * Copyright (C) 2002 - 2008 Alkacon Software (http://www.alkacon.com)
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * For further information about Alkacon Software, please see the
+ * company website: http://www.alkacon.com
+ *
+ * For further information about OpenCms, please see the
+ * project website: http://www.opencms.org
+ * 
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+ 
+package org.opencms.widgets;
+
+import org.opencms.test.OpenCmsTestCase;
+import org.opencms.test.OpenCmsTestProperties;
+
+import junit.extensions.TestSetup;
+import junit.framework.Test;
+import junit.framework.TestSuite;
+
+/**
+ *  TestCase for {@link CmsVfsFileWidget}.
+ */
+public class TestVfsFileWidgetConfiguration extends OpenCmsTestCase {
+
+    /**
+     * Default JUnit constructor.<p>
+     * 
+     * @param arg0 JUnit parameters
+     */
+    public TestVfsFileWidgetConfiguration(String arg0) {
+
+        super(arg0);
+    }
+
+    /**
+     * Test suite for this test class.<p>
+     * 
+     * @return the test suite
+     */
+    public static Test suite() {
+
+        OpenCmsTestProperties.initialize(org.opencms.test.AllTests.TEST_PROPERTIES_PATH);
+
+        TestSuite suite = new TestSuite();
+        suite.setName(TestVfsFileWidgetConfiguration.class.getName());
+
+        suite.addTest(new TestVfsFileWidgetConfiguration("testConfigurationHappyPath"));
+        suite.addTest(new TestVfsFileWidgetConfiguration("testConfigurationWrongResourceTypeName"));
+        suite.addTest(new TestVfsFileWidgetConfiguration("testConfigurationWrongParameter"));
+        suite.addTest(new TestVfsFileWidgetConfiguration("testConfigurationNull"));
+
+        TestSetup wrapper = new TestSetup(suite) {
+
+            @Override
+            protected void setUp() {
+
+                setupOpenCms("simpletest", "/sites/default/");
+            }
+
+            @Override
+            protected void tearDown() {
+
+                removeOpenCms();
+            }
+        };
+
+        return wrapper;
+    }
+    
+    /**
+     * Test HappyPath.
+     */
+    public void testConfigurationHappyPath() {
+        CmsVfsFileWidget cmsVfsFileWidget = new CmsVfsFileWidget("hidesiteselector|excludefiles|notprojectaware|resourcetypeNames=jsp,image,xmlpage");
+
+        assertEquals("hidesiteselector|excludefiles|notprojectaware|resourcetypeNames=jsp,image,xmlpage", cmsVfsFileWidget.getConfiguration());
+        // The Ids should be: jsp=4, image=3, xmlpage=6
+        assertEquals("4,3,6", cmsVfsFileWidget.getRestrictResTypeIdsAsString(","));
+    }
+    
+    /**
+     * Test wrong ResourceTypeName.
+     */
+    public void testConfigurationWrongResourceTypeName() {
+        CmsVfsFileWidget cmsVfsFileWidget = new CmsVfsFileWidget("hidesiteselector|excludefiles|notprojectaware|resourcetypeNames=jsp,image,unbekannt");
+
+        assertEquals("hidesiteselector|excludefiles|notprojectaware|resourcetypeNames=jsp,image,unbekannt", cmsVfsFileWidget.getConfiguration());
+        // The Ids should be: jsp=4, image=3 ("unbekannt" is not found and not listed.)
+        assertEquals("4,3", cmsVfsFileWidget.getRestrictResTypeIdsAsString(","));
+    }
+    
+    /**
+     * Test wrong ResourceTypeName.
+     */
+    public void testConfigurationWrongParameter() {
+        CmsVfsFileWidget cmsVfsFileWidget = new CmsVfsFileWidget("hidesiteselector|excludefiles|notprojectaware|resourcetypeNames=jsp|unbekannt");
+
+        assertEquals("hidesiteselector|excludefiles|notprojectaware|resourcetypeNames=jsp", cmsVfsFileWidget.getConfiguration());
+        // The Id should be: jsp=4
+        assertEquals("4", cmsVfsFileWidget.getRestrictResTypeIdsAsString(","));
+    }
+    
+    /**
+     * Test <code>null</code> configuration.
+     */
+    public void testConfigurationNull() {
+        CmsVfsFileWidget cmsVfsFileWidget = new CmsVfsFileWidget(null);
+        
+        assertEquals("showsiteselector|includefiles|projectaware", cmsVfsFileWidget.getConfiguration());
+        // The Ids should be: jsp=4, image=3 ("unbekannt" is not found and not listed.)
+        assertEquals("", cmsVfsFileWidget.getRestrictResTypeIdsAsString(","));
+    }
+}
